## passwordsafe 1.22.0+dfsg

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.13...3.25) # 3.13 is used by Debian 10

project (passwordsafe CXX C)

set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
# wxWidgets 3.2.1 doesn't compile under C++17 on some distros.
# 3.0.5 is fine, though...
# Need to revisit this and remove when no longer an issue
if (NOT WIN32 OR WX_WINDOWS)
    set(CMAKE_CXX_STANDARD 14)
else (NOT WIN32 OR WX_WINDOWS)
    set(CMAKE_CXX_STANDARD 17)
endif (NOT WIN32 OR WX_WINDOWS)

# prerequisites
include(CheckLibraryExists)
include(CheckIncludeFile)

# IPO = interprocedural optimisation, not initial public offering (unfortunately)
include(CheckIPOSupported OPTIONAL RESULT_VARIABLE CHECK_IPO_FOUND)
if (${CHECK_IPO_FOUND} STREQUAL "NOTFOUND")
else (${CHECK_IPO_FOUND} STREQUAL "NOTFOUND")
  check_ipo_supported(RESULT IPO_SUPPORTED)
endif (${CHECK_IPO_FOUND} STREQUAL "NOTFOUND")

if (IPO_SUPPORTED)
  option(USE_INTERPROCEDURAL_OPTIMIZATION "Enable interprocedural optimization (LTO/LTCG)" ON)

  if (USE_INTERPROCEDURAL_OPTIMIZATION)
    message(STATUS "Interprocedural optimization (LTO/LTCG) is enabled.")
    set(CMAKE_INTERPROCEDURAL_OPTIMIZATION ON)
    set(CMAKE_INTERPROCEDURAL_OPTIMIZATION_DEBUG OFF)

    # Propagate IPO settings to subdirectories
    set(CMAKE_POLICY_DEFAULT_CMP0069 NEW)
  endif ()
endif (IPO_SUPPORTED)

if (UNIX)
  set(CMAKE_POSITION_INDEPENDENT_CODE TRUE)
endif ()

if (NOT WIN32)
include(FindUnixCommands)
endif (NOT WIN32)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules")

include(create-harden-interface)


# Configurable options:
option (NO_YUBI "Set ON to disable YubiKey support" OFF)
option (NO_GTEST "Set ON to disable gtest unit testing" OFF)
option (GTEST_BUILD "Set OFF to disable gtest download and build on-fly" ON)

if (WIN32)
  option (WX_WINDOWS "Build wxWidget under Windows" OFF)
  if (WX_WINDOWS)
    option (XML_XERCESC "Set ON for XML import support with XercesC" ON)
  else (WX_WINDOWS)
    option (XML_MSXML "Set ON for XML import support with MSXML" ON)
    option (XML_XERCESC "Set ON for XML import support with XercesC" OFF)    
  endif (WX_WINDOWS)
  if (XML_MSXML AND XML_XERCESC)
    message (FATAL_ERROR "MSXML and XERCESC are mutually exclusive")
  endif (XML_MSXML AND XML_XERCESC)
  if (XML_MSXML AND WX_WINDOWS)
    message (FATAL_ERROR "MSXML is not supported for wxWidget under Windows")
  endif (XML_MSXML AND WX_WINDOWS)
else (WIN32)
  option (XML_XERCESC "Set OFF to disable XML import support" ON)
endif (WIN32)
if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  option (USE_ASAN "Set ON to add -fsanitize=address to Debug builds" OFF)
endif (${CMAKE_SYSTEM_NAME} MATCHES "Linux")

if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  option (NO_QR "Set ON to disable QR support" OFF)
  if (NOT NO_QR)
    CHECK_INCLUDE_FILE("qrencode.h" HAVE_LIBQRENCODE_DEV)
    if(NOT HAVE_LIBQRENCODE_DEV)
      unset(HAVE_LIBQRENCODE_DEV CACHE)
      message( FATAL_ERROR "libqrencode-dev(el) not installed: install or select NO_QR")
    endif(NOT HAVE_LIBQRENCODE_DEV)
  else (NOT NO_QR)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DNO_QR")
  endif (NOT NO_QR)
else(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
endif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")

if (NOT WIN32 OR WX_WINDOWS)
  if (NOT WIN32)
     # help people with wxWidgets on non-standard installation
     # quick-and-dirty since wxWdigets cmake's support is not yet loaded.
     find_program(PWSHINT_wxconfig wx-config)
     if (NOT PWSHINT_wxconfig)
       message(STATUS
               "Failed to find 'wx-config' executable:\n"
               "   Tip: can be pointed from command-line this way:\n"
               "        $ cmake -D wxWidgets_CONFIG_EXECUTABLE=/path/to/wx-config ."
               )
     endif (NOT PWSHINT_wxconfig)
  endif (NOT WIN32)
  find_package(wxWidgets COMPONENTS adv aui base core html net REQUIRED)
  include(${wxWidgets_USE_FILE})

  find_package(OpenSSL REQUIRED)
  include_directories(${OPENSSL_INCLUDE_DIR})

  if (NOT APPLE)
    find_package(Magic REQUIRED)
    include_directories(${MAGIC_INCLUDE_DIRS})
  endif (NOT APPLE)
endif (NOT WIN32 OR WX_WINDOWS)

if (NOT WIN32)
    if (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
      set( CMAKE_REQUIRED_INCLUDES "/usr/local/include" )
    endif (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
    if (${CMAKE_SYSTEM_NAME} MATCHES "OpenBSD")
	  CHECK_INCLUDE_FILE("uuid.h" UUID_H)
    else ()
	  CHECK_INCLUDE_FILE("uuid/uuid.h" UUID_H)
    endif (${CMAKE_SYSTEM_NAME} MATCHES "OpenBSD")
  if (NOT UUID_H)
    message(FATAL_ERROR
      "uuid.h not found - uuid-dev / libuuid-devel not installed?")
  endif(NOT UUID_H)
  if(NOT NO_YUBI)
    CHECK_LIBRARY_EXISTS(ykpers-1 yk_init "ykpers-1/ykpers.h" HAVE_YKPERS_H)
  endif(NOT NO_YUBI)

  if(NOT HAVE_YKPERS_H)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DNO_YUBI")
    message(STATUS "Yubikey support disabled")
  endif(NOT HAVE_YKPERS_H)
endif (NOT WIN32)

if (XML_XERCESC)
  find_package (XercesC QUIET MODULE)
  if (NOT XercesC_FOUND)
    # FindXercesC module was added to cmake in 3.1. Debian 8 uses 3.0.2
    # If the module wasn't found yet XML is enabled, we set the default
    # values. If this isn't what you want, either configure NO_XML
    # or edit the following values manually.
    if (NOT XercesC_INCLUDE_DIR)
      message (WARNING "XML enabled but XercesC_INCLUDE_DIR unset - using default")
      set (XercesC_INCLUDE_DIR "/usr/include")
    endif ()
    if (NOT XercesC_LIBRARY)
      message (WARNING "XML enabled but XercesC_LIBRARY unset - using default")
      set (XercesC_LIBRARY "xerces-c")
    endif ()
  endif(NOT XercesC_FOUND)
  include_directories( ${XercesC_INCLUDE_DIR} )
  add_definitions ("-DUSE_XML_LIBRARY=XERCES")
endif (XML_XERCESC)

if (XML_MSXML)
  add_definitions ("-DUSE_XML_LIBRARY=MSXML")
  set (MSXML_LIB "msxml6")
endif (XML_MSXML)

if (USE_ASAN)
  # Requires libasan, which I can't get CHECK_LIBRARY_EXISTS to find under Debian
  CHECK_LIBRARY_EXISTS("asan" "" "" HAS_ASAN)
  CHECK_LIBRARY_EXISTS("asan" "" "/usr/lib/x86_64-linux-gnu/" HAS_ASAN1)
  if (NOT HAS_ASAN AND NOT HAS_ASAN1)
    message (WARNING
      "-fsanitize=address requested but libasan not found.")
  endif (NOT HAS_ASAN AND NOT HAS_ASAN1)
endif (USE_ASAN)

enable_testing()

# Common configurations

include_directories (${PROJECT_SOURCE_DIR}/src/os)
include_directories (${PROJECT_SOURCE_DIR}/src/core)
include_directories (${PROJECT_BINARY_DIR})
include_directories ("${PROJECT_SOURCE_DIR}/src"
  "${PROJECT_SOURCE_DIR}/src/core"
  "${PROJECT_SOURCE_DIR}/src/ui/wxWidgets")

add_compile_definitions(
  __STDC_WANT_LIB_EXT1__=1
  UNICODE
  $<$<CONFIG:DEBUG>:_DEBUG>
  $<$<NOT:$<CONFIG:DEBUG>>:NDEBUG>
)

# Assume that we're either MSVC or a Unix-like
if (MSVC)
# Debug build looks for dlls with _D postfix, this provides it:
set (CMAKE_DEBUG_POSTFIX "_D")
# This copies dlls to same directory as exec upon 'install' build
set (CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR})

set_property (GLOBAL PROPERTY USE_FOLDERS ON)

if (NO_YUBI)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DNO_YUBI")
endif (NO_YUBI)

if (WX_WINDOWS)
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /D __WX__")
endif (WX_WINDOWS)

include(set-options-msvc)
else ()
set(CMAKE_CXX_FLAGS
  "${CMAKE_CXX_FLAGS} -Wall -DUNICODE -DWCHAR_INCOMPATIBLE_XMLCH ${CMAKE_WXWINDOWS_CXX_FLAGS}")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -D_DEBUG -DDEBUG")
if (USE_ASAN)
  set(CMAKE_CXX_FLAGS_DEBUG
    "${CMAKE_CXX_FLAGS_DEBUG} -gdwarf-4 -O0 -fno-omit-frame-pointer -fno-optimize-sibling-calls -fsanitize=address")
endif (USE_ASAN)
endif (MSVC)

if (NOT NO_GTEST AND GTEST_BUILD)
   # Download and unpack googletest at configure time
   # See https://crascit.com/2015/07/25/cmake-gtest/
   configure_file(Misc/CMakeLists.gtest.txt.in googletest-download/CMakeLists.txt)
   execute_process(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
       WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/googletest-download" )
   execute_process(COMMAND "${CMAKE_COMMAND}" --build .
       WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/googletest-download" )

   # Prevent GoogleTest from overriding our compiler/linker options
   # when building with Visual Studio
   set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
   # Set some other gtest configurations:
   set(BUILD_GMOCK OFF CACHE BOOL "" FORCE)
   set(BUILD_GTEST ON CACHE BOOL "" FORCE)
   set(INSTALL_GTEST OFF CACHE BOOL "" FORCE)

   # Add googletest directly to our build. This adds
   # the following targets: gtest, gtest_main, gmock
   # and gmock_main
   add_subdirectory("${CMAKE_BINARY_DIR}/googletest-src"
                    "${CMAKE_BINARY_DIR}/googletest-build")

   include_directories("${gtest_SOURCE_DIR}/include"
#                       "${gmock_SOURCE_DIR}/include"
                       )
endif(NOT NO_GTEST AND GTEST_BUILD)

if( NOT CMAKE_BUILD_TYPE )
  set( CMAKE_BUILD_TYPE Release )
endif( NOT CMAKE_BUILD_TYPE )

if(HAVE_YKPERS_H)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -I/usr/include/ykpers-1")
  list(APPEND CMAKE_REQUIRED_LIBRARIES ykpers-1)
endif(HAVE_YKPERS_H)

if (NOT MSVC)
   # Following is because (a) -O3 breaks the test and application, and
   # (b) -O3 is the default for cmake
   set (CMAKE_CXX_FLAGS_RELEASE "-O2 -DNDEBUG")
endif (NOT MSVC)

include(pws-version)

if (WIN32)
   set (CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
endif (WIN32)

# Subdirectories

add_subdirectory (src/os) # os-specific library
add_subdirectory (src/core) # core library
add_subdirectory(src/ui/cli "./cli")
if (NOT NO_GTEST)
   add_subdirectory (src/test) # tests (gtest framework)
endif(NOT NO_GTEST)
add_subdirectory (help) # online help
if (WIN32 AND NOT WX_WINDOWS)
  add_subdirectory (src/Tools/Windows/I18N/ResText)
  add_subdirectory (src/Tools/Windows/I18N/ResPWSL)
  add_subdirectory (src/ui/Windows)
  add_subdirectory (src/ui/Windows/I18N)
else()
  add_subdirectory (src/ui/wxWidgets)
  if (NOT WIN32)
    # TBD - handle I18N under WX_WINDOWS.
    find_package(Gettext QUIET)
    if (GETTEXT_FOUND)
      add_subdirectory (src/ui/wxWidgets/I18N)
    else (GETTEXT_FOUND)
      message("Gettext support not found, skipping I18N build")
    endif(GETTEXT_FOUND)
  endif (NOT WIN32)
endif()

if (NOT WIN32)
  add_executable(pwsafe ${PWSAFE_SRCS})
else (NOT WIN32)
   add_executable(pwsafe WIN32 ${PWSAFE_SRCS})
   add_dependencies( pwsafe language-dlls) # i18n dlls
   if (NOT WX_WINDOWS)
      set (PWS_DLL_LIBS "pws_at" "pws_osk")
      set_target_properties(pwsafe PROPERTIES COMPILE_DEFINITIONS
                            "_BIND_TO_CURRENT_CRT_VERSION;_BIND_TO_CURRENT_MFC_VERSION"
                            LINK_FLAGS "/ENTRY:\"wWinMainCRTStartup\" /MAP /DEBUG")
   else (NOT WX_WINDOWS)
#      set_target_properties(pwsafe PROPERTIES COMPILE_DEFINITIONS
#                            _BIND_TO_CURRENT_CRT_VERSION
#                            LINK_FLAGS "/ENTRY:\"wWinMainCRTStartup\"")
   endif (NOT WX_WINDOWS)
endif (NOT WIN32)
target_link_libraries(pwsafe core os)
if (XML_XERCESC)
  target_link_libraries(pwsafe ${XercesC_LIBRARY})
endif (XML_XERCESC)

target_link_libraries(pwsafe pws_version)

if (APPLE)
  FIND_LIBRARY(QUARTZCORE_LIBS QuartzCore)
  target_link_libraries(pwsafe ${wxWidgets_LIBRARIES} ${CMAKE_REQUIRED_LIBRARIES} ${QUARTZCORE_LIBS} curl ${OPENSSL_SSL_LIBRARY})
elseif (WIN32)
  if (NOT NO_YUBI)
    set (YUBILIB "YkLib22")
  endif ()
  target_link_libraries(pwsafe ${wxWidgets_LIBRARIES} 
      ${YUBILIB} ${PWS_DLL_LIBS} version Rpcrt4 htmlhelp SetupAPI Hid usp10 bcrypt
      Dbghelp Urlmon gdiplus ${MSXML_LIB} ${CMAKE_REQUIRED_LIBRARIES})
else ()
  if (NOT NO_QR)
    target_link_libraries(pwsafe qrencode  ${CMAKE_REQUIRED_LIBRARIES})
  endif (NOT NO_QR)
  target_link_libraries(pwsafe ${wxWidgets_LIBRARIES} uuid Xtst X11 curl ${OPENSSL_SSL_LIBRARY} ${MAGIC_LIBRARIES}
  ${CMAKE_REQUIRED_LIBRARIES})
endif()

# Installation stuff (for 'make install', but mainly for 'make package')
install (TARGETS pwsafe RUNTIME DESTINATION "bin")

=== Makefile ===
OS:= $(findstring Linux, $(shell uname -s))
GPG_KEY := 7F2F1BB9

SF_UPLOAD_ROOT := ronys@frs.sourceforge.net:/home/frs/project/

ifeq ($(findstring Linux, $(shell uname -s)), Linux)
include Makefile.linux
else ifeq ($(findstring CYGWIN, $(shell uname -s)), CYGWIN)
include Makefile.windows
else ifeq ($(findstring Darwin, $(shell uname -s)), Darwin)
include Makefile.macos
else ifeq ($(findstring FreeBSD, $(shell uname -s)), FreeBSD)
include Makefile.freebsd
else ifeq ($(findstring OpenBSD, $(shell uname -s)), OpenBSD)
include Makefile.openbsd
else
$(error "Unsupported OS or unable to determine OS")
endif

=== help/CMakeLists.txt ===
set (LANGS "RU" "DE" "ES" "FR" "ZH" "PL")

macro(set_lang_help_files FILES_VAR DIR)
  file(GLOB_RECURSE ${FILES_VAR}
    LIST_DIRECTORIES FALSE
    RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}"
    ${DIR}/html/*
    ${DIR}/pwsafe*.hh?
  )
endmacro(set_lang_help_files)

if (WIN32 AND NOT WX_WINDOWS)
  set (LANGS DE ES FR RU SK ZH)
  # pwsafePL -- nothing there :-(

  find_program(HHC_EXECUTABLE hhc.exe DOC "Microsoft's help compiler (hhc.exe)")
  if (NOT HHC_EXECUTABLE)
    message(WARNING "The Microsoft help compiler was not found.")
    return()
  endif()

  function(make_help OUTPUT_FILE_VAR DIR LANG)
    set_lang_help_files(INPUT_FILES "${DIR}")

    set(OUTPUT_FILE_NAME "pwsafe${LANG}.chm")
    set(OUTPUT_FILE "${CMAKE_CURRENT_BINARY_DIR}/${DIR}/${OUTPUT_FILE_NAME}")

    add_custom_command(OUTPUT "${OUTPUT_FILE}"
                       DEPENDS ${INPUT_FILES} cmake/html_help_hhc.cmake
                       COMMAND "${CMAKE_COMMAND}"
                            -D "HHC_EXECUTABLE=${HHC_EXECUTABLE}"
                            -D "INPUT_DIR=${CMAKE_CURRENT_SOURCE_DIR}/${DIR}"
                            -D "OUTPUT_DIR=${CMAKE_CURRENT_BINARY_DIR}/${DIR}"
                            -D "OUTPUT_FILE=${OUTPUT_FILE}"
                            -D "OUTPUT_FILE_NAME=${OUTPUT_FILE_NAME}"
                            -P cmake/html_help_hhc.cmake
                       COMMENT "Compiling pwsafe ${LANG} help"
                       WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
                       VERBATIM
                       )

    set(${OUTPUT_FILE_VAR} "${OUTPUT_FILE}" PARENT_SCOPE)
  endfunction(make_help)

else (WIN32 AND NOT WX_WINDOWS)
  function(make_help OUTPUT_FILE_VAR DIR LANG)
    set_lang_help_files(INPUT_FILES "${DIR}")

    set(OUTPUT_FILE "${CMAKE_CURRENT_BINARY_DIR}/help${LANG}.zip")

    add_custom_command(OUTPUT "${OUTPUT_FILE}"
      COMMAND "${CMAKE_COMMAND}" -E tar cf "${OUTPUT_FILE}" . --format=zip
      WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/${DIR}"
      VERBATIM
      )

    set(${OUTPUT_FILE_VAR} "${OUTPUT_FILE}" PARENT_SCOPE)
  endfunction(make_help)
endif (WIN32 AND NOT WX_WINDOWS)

unset(OUTPUT_FILES)

# English help is a special case: default -> pwsafe.chm

if (WIN32 AND NOT WX_WINDOWS)
  make_help(DEFAULT_OUTPUT_FILE default "")
else()
  make_help(DEFAULT_OUTPUT_FILE default EN)
endif()

set(OUTPUT_FILES "${DEFAULT_OUTPUT_FILE}")

foreach (LANG ${LANGS})
  make_help(OUTPUT_FILE "pwsafe${LANG}" ${LANG})
  list(APPEND OUTPUT_FILES "${OUTPUT_FILE}")
endforeach(LANG)

if (WIN32 AND NOT WX_WINDOW)
option(PWS_BUILD_HELP "Build the help files by default." OFF)
else()
option(PWS_BUILD_HELP "Build the help files by default." ON)
endif()

if (PWS_BUILD_HELP)
  add_custom_target(helpfiles ALL DEPENDS ${OUTPUT_FILES})
else()
  add_custom_target(helpfiles DEPENDS ${OUTPUT_FILES})
endif ()

=== help/Makefile ===
OS:= $(findstring Linux, $(shell uname -s))

ifeq ($(findstring Linux, $(shell uname -s)), Linux)
include Makefile.linux
else ifeq ($(findstring CYGWIN, $(shell uname -s)), CYGWIN)
include Makefile.windows
else ifeq ($(findstring Darwin, $(shell uname -s)), Darwin)
include Makefile.macos
else ifeq ($(findstring FreeBSD, $(shell uname -s)), FreeBSD)
include Makefile.freebsd
else
$(error "Unsupported OS or unable to determine OS")
endif

=== src/core/CMakeLists.txt ===
include(CheckLibraryExists)

set (CORE_SRCS
 
  CheckVersion.cpp
  Command.cpp
  CoreAlias.cpp
  CoreImpExp.cpp
  CoreOtherDB.cpp
  ExpiredList.cpp
  ItemAtt.cpp
  Item.cpp
  ItemData.cpp
  ItemField.cpp
  Match.cpp
  PolicyManager.cpp
  PWCharPool.cpp
  PWHistory.cpp
  PWPolicy.cpp
  PWSAuxParse.cpp
  PWScore.cpp
  PWSdirs.cpp
  PWSfile.cpp
  PWSfileHeader.cpp
  PWSfileV1V2.cpp
  PWSfileV3.cpp
  PWSfileV4.cpp
  PWSFilters.cpp
  PWSLog.cpp
  PWSprefs.cpp
  PWSrand.cpp
  PWStime.cpp
  Report.cpp
  RUEList.cpp
  StringX.cpp
  SysInfo.cpp
  TotpCore.cpp
  UnknownField.cpp
  UTF8Conv.cpp
  Util.cpp
  Validate.cpp
  VerifyFormat.cpp
  XMLprefs.cpp
  crypto/AES.cpp
  crypto/BlowFish.cpp
  crypto/KeyWrap.cpp
  crypto/pbkdf2.cpp
  crypto/sha1.cpp
  crypto/sha256.cpp
  crypto/TwoFish.cpp
  crypto/external/Chromium/base32.cpp
  XML/XMLFileHandlers.cpp
  XML/XMLFileValidation.cpp
  pugixml/pugixml.cpp
  )

if (XML_MSXML)
  list (APPEND CORE_SRCS
    XML/MSXML/MFileSAX2Handlers.cpp
    XML/MSXML/MFileValidator.cpp
    XML/MSXML/MFileXMLProcessor.cpp
    XML/MSXML/MFilterSAX2Handlers.cpp
    XML/MSXML/MFilterXMLProcessor.cpp
  )
endif (XML_MSXML)

if (XML_XERCESC)
  list (APPEND CORE_SRCS
    XML/Xerces/XFileSAX2Handlers.cpp
    XML/Xerces/XFileValidator.cpp
    XML/Xerces/XFileXMLProcessor.cpp
    XML/Xerces/XFilterSAX2Handlers.cpp
    XML/Xerces/XFilterXMLProcessor.cpp
    XML/Xerces/XSecMemMgr.cpp
   )
endif (XML_XERCESC)

if (NOT XML_MSXML AND NOT XML_XERCESC)
  list (APPEND CORE_SRCS
    XML/Pugi/PFileXMLProcessor.cpp
    XML/Pugi/PFilterXMLProcessor.cpp
  )
endif (NOT XML_MSXML AND NOT XML_XERCESC)

if (NOT WIN32 OR WX_WINDOWS)
  list (APPEND CORE_SRCS ${CMAKE_CURRENT_BINARY_DIR}/core_st.cpp)
  if (WIN32)
    set (PERL_EXECUTABLE "Perl_executable_undefined" CACHE FILEPATH
    "Path to perl.exe, from activestate.com or Cygwin") 
    set (MV "move")
    string (REPLACE "/" "\\" FROM "${PROJECT_SOURCE_DIR}/src/core/core_st")
    string (REPLACE "/" "\\" TO "${CMAKE_CURRENT_BINARY_DIR}/core_st")
  else (WIN32)
    set (PERL_EXECUTABLE "perl")
    set (MV "mv")
    set (FROM "${PROJECT_SOURCE_DIR}/src/core/core_st")
    set (TO "${CMAKE_CURRENT_BINARY_DIR}/core_st")
  endif (WIN32)
  set (RC2CPP "${PROJECT_SOURCE_DIR}/Misc/rc2cpp.pl")

  add_custom_command (
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/core_st.cpp ${CMAKE_CURRENT_BINARY_DIR}/core_st.h
    COMMAND "${PERL_EXECUTABLE}" "${RC2CPP}" "${PROJECT_SOURCE_DIR}/src/core/core.rc2"
    COMMAND "${MV}" "${FROM}.cpp" "${TO}.cpp"
    COMMAND "${MV}" "${FROM}.h" "${TO}.h"
    DEPENDS core.rc2
    )
  include_directories(${CMAKE_CURRENT_BINARY_DIR})
else (NOT WIN32 OR WX_WINDOWS)
  list (APPEND CORE_SRCS core.rc2)
endif(NOT WIN32 OR WX_WINDOWS)

add_library(core STATIC ${CORE_SRCS})
target_link_libraries(core PRIVATE harden_interface)

=== src/os/CMakeLists.txt ===
include(CheckLibraryExists)

if (WIN32)
  set (OS_SRCS
    windows/debug.cpp
    windows/dir.cpp
    windows/env.cpp
    windows/file.cpp
    windows/getopt.c
    windows/KeySend.cpp
    windows/lib.cpp
    windows/logit.cpp
    windows/media.cpp
    windows/mem.cpp
    windows//pws_str.cpp
    windows/rand.cpp
    windows/registry.cpp
    windows/run.cpp
    windows/sleep.cpp
    windows/utf8conv.cpp
    windows/UUID.cpp
    )
if (NOT NO_YUBI)
    list(APPEND OS_SRCS
        windows/yubi/stdafx.cpp
        windows/yubi/YkLib.cpp)
endif ()

if (NOT WX_WINDOWS)
    add_subdirectory (windows/pws_autotype)
    add_subdirectory (windows/pws_osk)
endif (NOT WX_WINDOWS)

if (NOT NO_YUBI)
    add_subdirectory (windows/yubi)
endif ()
  elseif (APPLE)
  set (OS_SRCS
    mac/cleanup.cpp
    mac/debug.cpp
    mac/dir.cpp
    mac/env.cpp
    mac/file.cpp
    mac/KeySend.cpp
    mac/logit.cpp
    mac/macsendstring.cpp
    mac/mem.cpp
    mac/pws_str.cpp
    mac/pws_time.cpp
    mac/rand.cpp
    mac/registry.cpp
    mac/run.cpp
    mac/sleep.cpp
    mac/utf8conv.cpp
    mac/UUID.cpp
    mac/media.cpp
    )
  elseif (${CMAKE_SYSTEM_NAME} MATCHES "(Linux|FreeBSD|OpenBSD)")
  set (OS_SRCS
    unix/KeySend.cpp
    unix/UUID.cpp
    unix/cleanup.cpp
    unix/debug.cpp
    unix/dir.cpp
    unix/env.cpp
    unix/file.cpp
    unix/keyname.cpp
    unix/logit.cpp
    unix/media.cpp
    unix/mem.cpp
    unix/pws_str.cpp
    unix/pws_time.cpp
    unix/rand.cpp
    unix/registry.cpp
    unix/run.cpp
    unix/sleep.cpp
    unix/unicode2keysym.cpp
    unix/utf8conv.cpp
    unix/xsendstring.cpp
    )
  set (OS_YUBI_SRC unix/PWYubi.cpp)
else()
  message (FATAL_ERROR "Unsupported OS "
    ${CMAKE_SYSTEM_NAME}
    " - can't build OS library")
endif()

if(HAVE_YKPERS_H)
    list(APPEND OS_SRCS ${OS_YUBI_SRC})
endif()

add_library(os STATIC ${OS_SRCS})
target_link_libraries(os PRIVATE harden_interface)

=== src/test/CMakeLists.txt ===
set (TEST_SRCS
  AESTest.cpp AliasShortcutTest.cpp FileV3Test.cpp ItemAttTest.cpp OSTest.cpp BlowFishTest.cpp
  FileV4Test.cpp ItemDataTest.cpp SHA256Test.cpp SHA1Test.cpp CommandsTest.cpp ItemFieldTest.cpp
  StringXTest.cpp coretest.cpp HMAC_SHA256Test.cpp HMAC_SHA1Test.cpp KeyWrapTest.cpp TwoFishTest.cpp
  AuxParseTest.cpp UtilTest.cpp FileEncDecTest.cpp ImportTextTest.cpp TOTPTest.cpp Base32Test.cpp
  ValidateTest.cpp MRUListTest.cpp)

if (WIN32)
  list (APPEND TEST_SRCS ../core/core.rc2)
  set_source_files_properties(../core/core.rc2 PROPERTIES LANGUAGE RC)
endif(WIN32)


# Setup test data
file (MAKE_DIRECTORY "data")
file (COPY "data/image1.jpg" DESTINATION "data")
file (COPY "data/text1.txt" DESTINATION "data")
file (COPY "data/import-text-unit-test1.txt" DESTINATION "data")
file (COPY "data/import-text-unit-test2.csv" DESTINATION "data")
file (COPY "data/import-text-unit-test3.csv" DESTINATION "data")
file (COPY "data/import-text-unit-test4.csv" DESTINATION "data")
file (COPY "data/import-text-unit-test5.csv" DESTINATION "data")

add_executable(coretest ${TEST_SRCS})
if (MSVC)
set_target_properties(coretest PROPERTIES EXCLUDE_FROM_DEFAULT_BUILD_RELEASE 1)
target_link_libraries(coretest gtest core os Rpcrt4 bcrypt harden_interface)
elseif (APPLE)
target_link_libraries(coretest gtest core os pthread ${wxWidgets_LIBRARIES} "-framework CoreFoundation" "-framework CoreServices")
else ()
target_link_libraries(coretest gtest core os uuid pthread magic ${wxWidgets_LIBRARIES} Xtst X11)
endif()
if (XercesC_LIBRARY)
  target_link_libraries(coretest ${XercesC_LIBRARY})
endif (XercesC_LIBRARY)

target_link_libraries(coretest harden_interface)

add_test(NAME Coretests
  COMMAND coretest
  )

=== src/test/Makefile ===
# Baby Makefile for Linux
#

CONFIG ?=unicodedebug

# Following sets WX_CONFIG to 3.0 version if found, else 2.x:
ifeq ($(PLATFORM),FreeBSD)
WX2=/usr/local/bin/wxgtk2y-2.8-config
WX3=/usr/local/bin/wxgtk2u-3.0-config
else
WX2=/usr/bin/wx-config
WX3=/usr/bin/wx-config-3.0
endif

WX_CONFIG?=$(shell if [ -e $(WX3) ]; then echo $(WX3); else echo $(WX2); fi)



BUILD			:= $(CONFIG)

TESTSRC         := coretest.cpp $(wildcard *Test.cpp)

OBJPATH         = ../../obj/$(BUILD)
LIBPATH         = ../../lib/$(BUILD)
BINPATH         = ./bin
INCPATH         = ..

# libgtest: Packages do not include a compiled library.
# Debian's package installs source in /usr/src/gtest
GTEST_DIR     = /usr/src/gtest
GTEST_HEADERS = /usr/include/gtest/*.h \
				/usr/include/gtest/internal/*.h
GTEST_SRCS_   = $(GTEST_DIR)/src/*.cc \
				$(GTEST_DIR)/src/*.h $(GTEST_HEADERS)
GTEST_OBJ = $(OBJPATH)/gtest-all.o

#destination related macros
TESTOBJ	 = $(addprefix $(OBJPATH)/,$(subst .cpp,.o,$(TESTSRC)))
TEST	   = $(BINPATH)/coretest
OBJS     = $(TESTOBJ) $(GTEST_OBJ)

CXXFLAGS += -DUNICODE -Wall -I$(INCPATH) -I$(INCPATH)/core -std=c++11
LDFLAGS  += -L$(LIBPATH) -lcore -los -luuid -lxerces-c -pthread -lX11 -lXtst -lmagic

ifeq ($(CONFIG),debug)
LDFLAGS += `$(WX_CONFIG) --debug=yes --unicode=no --libs`
else ifeq ($(CONFIG),release)
LDFLAGS += `$(WX_CONFIG) --debug=no --unicode=no --libs`
else ifeq ($(CONFIG),unicodedebug)
LDFLAGS += `$(WX_CONFIG) --debug=yes --unicode=yes --libs`
else ifeq ($(CONFIG),unicoderelease)
LDFLAGS += `$(WX_CONFIG) --debug=no --unicode=yes --libs`
endif

# rules
.PHONY: all clean test run setup

$(OBJPATH)/%.o : %.c
	$(CC) -g  $(CFLAGS)   -c $< -o $@

$(OBJPATH)/%.o : %.cpp
	$(CXX) -g $(CXXFLAGS) -c $< -o $@

all : setup test

$(GTEST_OBJ): $(GTEST_SRCS_) $(GTEST_HEADERS)
	$(CXX) -g $(CPPFLAGS) -I$(GTEST_DIR) $(CXXFLAGS) -c -o $@ \
	$(GTEST_DIR)/src/gtest-all.cc


run test : $(TEST)
	$(TEST)

$(TEST): $(LIB) $(OBJS)
	$(CXX) -g $(CXXFLAGS) $(filter %.o,$^) $(LDFLAGS) -o $@

clean:
	rm -f *~ $(OBJ) $(TEST) $(DEPENDFILE)

setup:
	@mkdir -p $(OBJPATH) $(LIBPATH) $(BINPATH)

=== src/os/unix/Makefile ===
# Makefile for Linux os-dependent library of
# pwsafe
#

#CONFIG=debug
#CONFIG=release
CONFIG?=unicodedebug
#CONFIG=unicoderelease

# Following sets WX_CONFIG to 3.0 version if found, else 2.x:
ifeq ($(PLATFORM),FreeBSD)
WX2=/usr/local/bin/wxgtk2u-2.8-config
WX3=/usr/local/bin/wxgtk2u-3.0-config
else ifeq ($(PLATFORM),OpenBSD)
WX3=/usr/local/bin/wx-config
else
WX2=/usr/bin/wx-config
WX3=/usr/bin/wx-config-3.0
endif

WX_CONFIG?=$(shell if [ -e $(WX3) ]; then echo $(WX3); else echo $(WX2); fi)

CPPINC=`$(WX_CONFIG) --debug=no --unicode=yes --inplace --cxxflags`

DEPDIR= ./deps

NAME=os

PKG_CONFIG ?= pkg-config

ifndef NO_YUBI
YUBI_SRC=PWYubi.cpp
# Use the following if you've installed ykpers-1 manually
# from https://github.com/Yubico/yubikey-personalization.git
# YBPERSFLAGS?=/usr/local/include/ykpers-1

# If you've installed it from your distro's package repo, you
# should use this instead:
YBPERSFLAGS=$(shell $(PKG_CONFIG) --cflags ykpers-1)
endif

LIBSRC          = cleanup.cpp debug.cpp dir.cpp env.cpp \
                  file.cpp logit.cpp media.cpp \
									mem.cpp pws_str.cpp \
                  pws_time.cpp rand.cpp run.cpp\
                  utf8conv.cpp KeySend.cpp\
                  sleep.cpp xsendstring.cpp keyname.cpp \
                  registry.cpp UUID.cpp\
                  unicode2keysym.cpp $(YUBI_SRC)

SRC             = $(LIBSRC)

OBJPATH         = ../../../obj/$(CONFIG)/$(NAME)
LIBPATH         = ../../../lib/$(CONFIG)

#destination related macros
LIBOBJ    = $(addprefix $(OBJPATH)/,$(subst .cpp,.o,$(LIBSRC)))
LIB       = $(LIBPATH)/libos.a
OBJ       = $(LIBOBJ)

CPPFLAGS := $(CXXFLAGS) -fPIC -Wall -I../../core -I../.. $(CPPINC) $(YBPERSFLAGS) \
                $(CPPFLAGS)

ifeq ($(CONFIG),debug)
CPPFLAGS += -O0 -g -ggdb -DDEBUG
CFLAGS += -g
else ifeq ($(CONFIG),release)
CPPFLAGS += -O -DNDEBUG
else ifeq ($(CONFIG),unicodedebug)
CPPFLAGS += -O0 -g -ggdb -DUNICODE -DDEBUG
CFLAGS += -g
else ifeq ($(CONFIG),unicoderelease)
CPPFLAGS += -O -DUNICODE -DNDEBUG
endif

# rules
.PHONY: all debug release unicodedebug unicoderelease clean setup

$(OBJPATH)/%.o : %.c
	$(CC)  $(CFLAGS)   -c $< -o $@

$(OBJPATH)/%.o : %.cpp
	$(CXX) $(CPPFLAGS) -c $< -o $@

all : setup $(LIB)

debug release unicodedebug unicoderelease:
	$(MAKE) all CONFIG=$@

$(LIB): $(LIBOBJ)
	ar rvus $@ $(filter %.o,$^)

clean:
	@rm -f *~ $(OBJ) $(TEST) $(LIB)
	@rm -rf $(DEPDIR)

setup:
	@mkdir -p $(OBJPATH) $(LIBPATH)

$(DEPDIR)/%.d: %.cpp
	@set -e; mkdir -p $(DEPDIR); $(RM) $@; \
	$(CXX) -MM $(CPPFLAGS) $< > $@.$$$$; \
	sed 's,\($*\)\.o[ :]*,$(OBJECTPATH)/\1.o $@ : ,g' < $@.$$$$ > $@; \
	$(RM) $@.$$$$

-include $(SRC:%.cpp=$(DEPDIR)/%.d)

=== src/ui/cli/CMakeLists.txt ===
set (CLI_SRCS
  main.cpp
  search.cpp
  argutils.cpp
  searchaction.cpp
  strutils.cpp
  safeutils.cpp
  diff.cpp
  impexp.cpp)

set (CLI_TEST_SRCS
  add-entry-test.cpp
  arg-fields-test.cpp
  split-test.cpp
  safeutils.cpp
  argutils.cpp
  searchaction.cpp
  strutils.cpp
  search-test.cpp
  search.cpp)

if (WIN32)
  list (APPEND CLI_SRCS cli.rc)
  list (APPEND CLI_TEST_SRCS cli.rc)
  set_source_files_properties(cli.rc PROPERTIES LANGUAGE RC)
endif(WIN32)


add_executable(pwsafe-cli ${CLI_SRCS})
target_link_libraries(pwsafe-cli harden_interface)

install (TARGETS pwsafe-cli RUNTIME DESTINATION "bin")

if (IPO_SUPPORTED)
  set_property(TARGET pwsafe-cli PROPERTY INTERPROCEDURAL_OPTIMIZATION_RELEASE True)
endif (IPO_SUPPORTED)

target_link_libraries(pwsafe-cli core os core ${wxWidgets_LIBRARIES})
if (XercesC_LIBRARY)
  target_link_libraries(pwsafe-cli ${XercesC_LIBRARY})
endif (XercesC_LIBRARY)

if (NOT APPLE)
  target_link_libraries(pwsafe-cli uuid)
endif (NOT APPLE)

if (NOT APPLE AND NOT WIN32)
  target_link_libraries(pwsafe-cli magic)
endif (NOT APPLE AND NOT WIN32)


if (NOT WIN32)
	target_link_libraries(pwsafe-cli pthread)
else ()
	target_link_libraries(pwsafe-cli Rpcrt4 bcrypt)
	set_target_properties(pwsafe-cli PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}")
endif (NOT WIN32)

# Add test executable
if (NOT NO_GTEST)
  add_executable(pwsafe-cli-test ${CLI_TEST_SRCS})
  set_target_properties(pwsafe-cli-test PROPERTIES EXCLUDE_FROM_DEFAULT_BUILD_RELEASE 1)
  target_link_libraries(pwsafe-cli-test harden_interface gtest gtest_main core os core ${wxWidgets_LIBRARIES})

if (XercesC_LIBRARY)
  target_link_libraries(pwsafe-cli-test ${XercesC_LIBRARY})
endif (XercesC_LIBRARY)

if (NOT APPLE)
  target_link_libraries(pwsafe-cli-test uuid)
endif (NOT APPLE)

if (NOT APPLE AND NOT WIN32)
  target_link_libraries(pwsafe-cli-test magic)
endif (NOT APPLE AND NOT WIN32)

if (NOT WIN32)
  target_link_libraries(pwsafe-cli-test pthread)
else ()
  target_link_libraries(pwsafe-cli-test Rpcrt4 bcrypt)
  set_target_properties(pwsafe-cli-test PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}")
endif (NOT WIN32)

# Add test target
  if (NOT WIN32) # Windows cli-test broken, doesn't recognize rc resources.
    add_test(NAME cli-test
      COMMAND pwsafe-cli-test
      WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    )
  endif (NOT WIN32)
endif(NOT NO_GTEST)

=== src/ui/cli/Makefile ===
# Baby Makefile for Linux
#

SRC         = main.cpp search.cpp argutils.cpp searchaction.cpp strutils.cpp \
			  safeutils.cpp diff.cpp impexp.cpp

TESTSRC         = add-entry-test.cpp arg-fields-test.cpp split-test.cpp \
				  safeutils.cpp argutils.cpp searchaction.cpp strutils.cpp \
				  search-test.cpp search.cpp

COREPATH        = ../../core
OSPATH          = ../../os
LIBPATH         = ../../../lib/unicodedebug
OBJPATH         = ../../../obj/unicodedebug/cli
BINPATH         = .

#destination related macros
OBJ	 = $(addprefix $(OBJPATH)/,$(subst .cpp,.o,$(SRC)))
EXE	    = $(BINPATH)/pwsafe-cli

TESTOBJ	 = $(addprefix $(OBJPATH)/,$(subst .cpp,.o,$(TESTSRC)))
TESTEXE	= $(BINPATH)/pwsafe-cli-test

LIBCORE	= $(LIBPATH)/libcore.a
LIBOS  	= $(LIBPATH)/libos.a
LIBS    = $(LIBCORE) $(LIBOS)

export CPPFLAGS += -std=c++11
ifeq ($(findstring Darwin, $(shell uname -s)), Darwin)
	XERCESCPPFLAGS=
	PLATFORM=mac
	EXTLIBS=-framework CoreFoundation -framework CoreGraphics
	TEST_EXTLIBS=-framework gtest $(EXTLIBS)
	# typically installed by homebrew etc.
	WX_CONFIG?=/usr/local/bin/wx-config
else
	XERCESCPPFLAGS=-DUSE_XML_LIBRARY=XERCES -DWCHAR_INCOMPATIBLE_XMLCH
	PLATFORM=unix
	GTEST_DIR=/usr/src/gtest
	GTEST_HEADERS=/usr/include/gtest/*.h /usr/include/gtest/internal/*.h
	GTEST_SRCS=$(GTEST_DIR)/src/*.cc $(GTEST_DIR)/src/*.h $(GTEST_HEADERS)
	GTEST_OBJ = $(OBJPATH)/gtest-all.o
	EXTLIBS=-luuid -lxerces-c -lpthread -lmagic
	TEST_EXTLIBS=$(EXTLIBS)
	WX_CONFIG?=/usr/bin/wx-config
endif

CXXFLAGS += $(CPPFLAGS) -Wall -I$(COREPATH) -I../.. $(XERCESCPPFLAGS) -DUNICODE
WXLIBS:=`$(WX_CONFIG) --debug=no --unicode=yes --libs`

# rules
.PHONY: all clean deepclean setup

$(OBJPATH)/%.o : %.c
	$(CC) -g  $(CFLAGS)   -c $< -o $@

$(OBJPATH)/%.o : %.cpp
	$(CXX) -g $(CXXFLAGS) -c $< -o $@

all : setup $(EXE) $(TESTEXE)


$(LIBCORE): 
	$(MAKE) -C $(COREPATH) WX_CONFIG=$(WX_CONFIG)

$(LIBOS): 
	$(MAKE) -C $(OSPATH)/$(PLATFORM)

$(EXE): $(LIBS) $(OBJ)
	$(CXX) -g $(filter %.o,$^)  -o $@ $(LD_FLAGS) \
	-L$(LIBPATH) -lcore -los -lcore $(EXTLIBS) $(WXLIBS)

clean:
	rm -f *~ $(OBJ) $(EXE) $(LIBS) $(DEPENDFILE)

deepclean: clean
	$(MAKE) -C $(COREPATH) clean

setup:
	@mkdir -p $(OBJPATH) $(BINPATH)

test: $(GTEST_OBJ) $(TESTEXE)

$(GTEST_OBJ): $(GTEST_SRCS_) $(GTEST_HEADERS)
	$(CXX) -g $(CPPFLAGS) -I$(GTEST_DIR) $(CXXFLAGS) -c -o $@ \
	$(GTEST_DIR)/src/gtest-all.cc

$(TESTEXE): $(LIBS) $(TESTOBJ)
	$(CXX) -v -g $(CXXFLAGS) $(filter %.o,$^)  -o $@  $(LD_FLAGS) \
	-L$(LIBPATH) -lcore -los -lcore $(TEST_EXTLIBS) $(GTEST_OBJ) $(WXLIBS)

=== src/ui/wxWidgets/CMakeLists.txt ===
list(APPEND PWSAFE_HDR_LIST
    src/ui/wxWidgets/PWSafeApp.h
    src/ui/wxWidgets/PasswordSafeFrame.h
    src/ui/wxWidgets/AboutDlg.h
    src/ui/wxWidgets/OptionsPropertySheetDlg.h
    src/ui/wxWidgets/PasswordSafeSearch.h
    src/ui/wxWidgets/ViewReportDlg.h
    src/ui/wxWidgets/GuiInfo.h
    src/ui/wxWidgets/HelpMap.h
    src/ui/wxWidgets/wxMessages.h
    src/ui/wxWidgets/GridShortcutsValidator.h
    src/ui/wxWidgets/SafeCombinationChangeDlg.h
    src/ui/wxWidgets/SafeCombinationEntryDlg.h
    src/ui/wxWidgets/SafeCombinationSetupDlg.h
    src/ui/wxWidgets/AddEditPropSheetDlg.h
    src/ui/wxWidgets/SelectAliasDlg.h
    src/ui/wxWidgets/PropertiesDlg.h
    src/ui/wxWidgets/Clipboard.h
    src/ui/wxWidgets/CreateShortcutDlg.h
    src/ui/wxWidgets/DeleteConfirmationDlg.h
    src/ui/wxWidgets/EditShortcutDlg.h
    src/ui/wxWidgets/FieldSelectionDlg.h
    src/ui/wxWidgets/FieldSelectionPanel.h
    src/ui/wxWidgets/wxUtilities.h
    src/ui/wxWidgets/AdvancedSelectionDlg.h
    src/ui/wxWidgets/CompareDlg.h
    src/ui/wxWidgets/ComparisonGridTable.h
    src/ui/wxWidgets/DbSelectionPanel.h
    src/ui/wxWidgets/ExportTextWarningDlg.h
    src/ui/wxWidgets/ExternalKeyboardButton.h
    src/ui/wxWidgets/ImportTextDlg.h
    src/ui/wxWidgets/ImportXmlDlg.h
    src/ui/wxWidgets/ManagePasswordPoliciesDlg.h
    src/ui/wxWidgets/MergeDlg.h
    src/ui/wxWidgets/OpenFilePickerValidator.h
    src/ui/wxWidgets/DragBarCtrl.h
    src/ui/wxWidgets/GridCtrl.h
    src/ui/wxWidgets/GridTable.h
    src/ui/wxWidgets/StatusBar.h
    src/ui/wxWidgets/TreeCtrl.h
    src/ui/wxWidgets/PasswordPolicyDlg.h
    src/ui/wxWidgets/SyncWizard.h
    src/ui/wxWidgets/ToolbarButtons.h
    src/ui/wxWidgets/RecentDbList.h
    src/ui/wxWidgets/SafeCombinationCtrl.h
    src/ui/wxWidgets/SelectionCriteria.h
    src/ui/wxWidgets/SizeRestrictedPanel.h
    src/ui/wxWidgets/SystemTray.h
    src/ui/wxWidgets/SystemTrayMenuId.h
    src/ui/wxWidgets/SafeCombinationPromptDlg.h
    src/ui/wxWidgets/TimedTaskChain.h
    src/ui/wxWidgets/PasswordSubsetDlg.h
    src/ui/wxWidgets/CryptKeyEntryDlg.h
    src/ui/wxWidgets/SetDatabaseIdDlg.h
    src/ui/wxWidgets/SetFiltersDlg.h
    src/ui/wxWidgets/ManageFiltersDlg.h
    src/ui/wxWidgets/ViewAttachmentDlg.h
    src/ui/wxWidgets/DnDFile.h
    src/ui/wxWidgets/DnDPWSafeObject.h
    src/ui/wxWidgets/DnDSupport.h
    src/ui/wxWidgets/DnDDropTarget.h
    src/ui/wxWidgets/PWFiltersGrid.h
    src/ui/wxWidgets/PWFiltersTable.h
    src/ui/wxWidgets/PWFiltersEditor.h
    src/ui/wxWidgets/PWFiltersBoolDlg.h
    src/ui/wxWidgets/PWFiltersStringDlg.h
    src/ui/wxWidgets/PWFiltersDCADlg.h
    src/ui/wxWidgets/PWFiltersIntegerDlg.h
    src/ui/wxWidgets/PWFiltersStatusDlg.h
    src/ui/wxWidgets/PWFiltersTypeDlg.h
    src/ui/wxWidgets/PWFiltersDateDlg.h
    src/ui/wxWidgets/PWFiltersMediaDlg.h
    src/ui/wxWidgets/PWFiltersPasswordDlg.h
    src/ui/wxWidgets/ManageFiltersTable.h
    src/ui/wxWidgets/StrengthMeter.h
    )


list(APPEND PWSAFE_SRC_LIST
    src/ui/wxWidgets/OptionsPropertySheetDlg.cpp
    src/ui/wxWidgets/CompareDlg.cpp
    src/ui/wxWidgets/ImportTextDlg.cpp
    src/ui/wxWidgets/AddEditPropSheetDlg.cpp
    src/ui/wxWidgets/SelectAliasDlg.cpp
    src/ui/wxWidgets/PasswordSafeSearch.cpp
    src/ui/wxWidgets/SystemTray.cpp
    src/ui/wxWidgets/AboutDlg.cpp
    src/ui/wxWidgets/GuiInfo.cpp
    src/ui/wxWidgets/Version.cpp
    src/ui/wxWidgets/Clipboard.cpp
    src/ui/wxWidgets/SafeCombinationEntryDlg.cpp
    src/ui/wxWidgets/MenuEditHandlers.cpp
    src/ui/wxWidgets/MenuFileHandlers.cpp
    src/ui/wxWidgets/MenuManageHandlers.cpp
    src/ui/wxWidgets/MenuViewHandlers.cpp
    src/ui/wxWidgets/ViewReportDlg.cpp
    src/ui/wxWidgets/SafeCombinationPromptDlg.cpp
    src/ui/wxWidgets/PasswordSafeFrame.cpp
    src/ui/wxWidgets/PropertiesDlg.cpp
    src/ui/wxWidgets/CreateShortcutDlg.cpp
    src/ui/wxWidgets/DeleteConfirmationDlg.cpp
    src/ui/wxWidgets/EditShortcutDlg.cpp
    src/ui/wxWidgets/FieldSelectionDlg.cpp
    src/ui/wxWidgets/FieldSelectionPanel.cpp
    src/ui/wxWidgets/GridShortcutsValidator.cpp
    src/ui/wxWidgets/SafeCombinationChangeDlg.cpp
    src/ui/wxWidgets/ExternalKeyboardButton.cpp
    src/ui/wxWidgets/PasswordPolicyDlg.cpp
    src/ui/wxWidgets/DbSelectionPanel.cpp
    src/ui/wxWidgets/PWSafeApp.cpp
    src/ui/wxWidgets/SafeCombinationSetupDlg.cpp
    src/ui/wxWidgets/wxUtilities.cpp
    src/ui/wxWidgets/AdvancedSelectionDlg.cpp
    src/ui/wxWidgets/ComparisonGridTable.cpp
    src/ui/wxWidgets/ExportTextWarningDlg.cpp
    src/ui/wxWidgets/ImportXmlDlg.cpp
    src/ui/wxWidgets/ManagePasswordPoliciesDlg.cpp
    src/ui/wxWidgets/MergeDlg.cpp
    src/ui/wxWidgets/OpenFilePickerValidator.cpp
    src/ui/wxWidgets/DragBarCtrl.cpp
    src/ui/wxWidgets/GridCtrl.cpp
    src/ui/wxWidgets/GridTable.cpp
    src/ui/wxWidgets/TreeCtrl.cpp
    src/ui/wxWidgets/SyncWizard.cpp
    src/ui/wxWidgets/SafeCombinationCtrl.cpp
    src/ui/wxWidgets/SelectionCriteria.cpp
    src/ui/wxWidgets/SizeRestrictedPanel.cpp
    src/ui/wxWidgets/TimedTaskChain.cpp
    src/ui/wxWidgets/PasswordSubsetDlg.cpp
    src/ui/wxWidgets/CryptKeyEntryDlg.cpp
    src/ui/wxWidgets/SetDatabaseIdDlg.cpp
    src/ui/wxWidgets/SetFiltersDlg.cpp
    src/ui/wxWidgets/ManageFiltersDlg.cpp
    src/ui/wxWidgets/ViewAttachmentDlg.cpp
    src/ui/wxWidgets/DnDFile.cpp
    src/ui/wxWidgets/DnDPWSafeObject.cpp
    src/ui/wxWidgets/DnDSupport.cpp
    src/ui/wxWidgets/DnDDropTarget.cpp
    src/ui/wxWidgets/PWFiltersGrid.cpp
    src/ui/wxWidgets/PWFiltersTable.cpp
    src/ui/wxWidgets/PWFiltersEditor.cpp
    src/ui/wxWidgets/PWFiltersBoolDlg.cpp
    src/ui/wxWidgets/PWFiltersStringDlg.cpp
    src/ui/wxWidgets/PWFiltersDCADlg.cpp
    src/ui/wxWidgets/PWFiltersIntegerDlg.cpp
    src/ui/wxWidgets/PWFiltersStatusDlg.cpp
    src/ui/wxWidgets/PWFiltersTypeDlg.cpp
    src/ui/wxWidgets/PWFiltersDateDlg.cpp
    src/ui/wxWidgets/PWFiltersMediaDlg.cpp
    src/ui/wxWidgets/PWFiltersPasswordDlg.cpp
    src/ui/wxWidgets/ManageFiltersTable.cpp
    src/ui/wxWidgets/QueryCancelDlg.cpp
    src/ui/wxWidgets/StrengthMeter.cpp
    )

if(HAVE_YKPERS_H)
  list(APPEND PWSAFE_SRC_LIST src/ui/wxWidgets/YubiCfgDlg.cpp src/ui/wxWidgets/YubiMixin.cpp)
  list(APPEND PWSAFE_HDR_LIST src/ui/wxWidgets/YubiCfgDlg.h src/ui/wxWidgets/YubiMixin.h)
endif(HAVE_YKPERS_H)

if (${CMAKE_SYSTEM_NAME} MATCHES "Linux" OR ${CMAKE_SYSTEM_NAME} MATCHES "OpenBSD")
if (NOT NO_QR)
  list(APPEND PWSAFE_SRC_LIST src/ui/wxWidgets/QRCodeDlg.cpp src/ui/wxWidgets/QREncode.cpp)
  list(APPEND PWSAFE_HDR_LIST src/ui/wxWidgets/QREncode.h src/ui/wxWidgets/QRCodeDlg.h)
endif(NOT NO_QR)
endif (${CMAKE_SYSTEM_NAME} MATCHES "Linux" OR ${CMAKE_SYSTEM_NAME} MATCHES "OpenBSD")

if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  list(APPEND PWSAFE_SRC_LIST src/ui/wxWidgets/QRCodeDlg.cpp src/ui/wxWidgets/QREncode.mm)
  list(APPEND PWSAFE_HDR_LIST src/ui/wxWidgets/QREncode.h src/ui/wxWidgets/QRCodeDlg.h)
endif (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")

set (PWSAFE_SRCS ${PWSAFE_SRC_LIST} PARENT_SCOPE)
set (PWSAFE_HDRS ${PWSAFE_HDR_LIST} PARENT_SCOPE)

=== debian/changelog ===
passwordsafe (1.22.0+dfsg-1) unstable; urgency=medium

  * New upstream version 1.22.0+dfsg
  * Add upstream patch to fix unaligned access, closes: 1118149

 -- William Blough <bblough@debian.org>  Sun, 19 Oct 2025 15:15:53 -0400

=== debian/control ===
Source: passwordsafe
Section: utils
Priority: optional
Maintainer: William Blough <bblough@debian.org>
Build-Depends: cmake,
               debhelper-compat (=13),
               libgtest-dev,
               libqrencode-dev,
               libmagic-dev,
               libwxgtk3.2-dev,
               libxerces-c-dev,
               libxt-dev,
               libxtst-dev,
               libykpers-1-dev,
               libyubikey-dev,
               pkgconf,
               uuid-dev,
               wx3.2-headers,
               zip
Standards-Version: 4.7.2
Homepage: https://pwsafe.org/
Vcs-Browser: https://salsa.debian.org/bblough/passwordsafe
Vcs-Git: https://salsa.debian.org/bblough/passwordsafe.git

Package: passwordsafe
Architecture: any
Conflicts: pwsafe
Depends: passwordsafe-common, ${misc:Depends}, ${shlibs:Depends}
Recommends: xvkbd
Description: Simple & Secure Password Management
 Password Safe allows you to safely and easily create a secured and
 encrypted user name/password list. With Password Safe all you have to do
 is create and remember a single "Master Password" of your choice in order
 to unlock and access your entire user name/password list.
 .
 This is the GNU/Linux version of the popular PasswordSafe password
 manager, originally designed by the renowned security technologist
 Bruce Schneier and open sourced in 2002.
 .
 Compatible with 1.x, 2.x and 3.x versions of the database format.

Package: passwordsafe-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: passwordsafe
Description: architecture independent files for Password Safe
 Password Safe allows you to safely and easily create a secured and
 encrypted user name/password list. With Password Safe all you have to do
 is create and remember a single "Master Password" of your choice in order
 to unlock and access your entire user name/password list.
 .
 This is the GNU/Linux version of the popular PasswordSafe password
 manager, originally designed by the renowned security technologist
 Bruce Schneier and open sourced in 2002.
 .
 Compatible with 1.x, 2.x and 3.x versions of the database format.
 .
 This package contains the parts of Password Safe that are common
 to all architectures, including in-program help files.

=== debian/tests/control ===
Tests: run-upstream-tests
Depends: cmake, libgtest-dev, libxerces-c-dev, libqrencode-dev, libmagic-dev,
         libwxgtk3.2-dev, libxt-dev, libxtst-dev, libykpers-1-dev,
         libyubikey-dev, pkgconf, uuid-dev, wx3.2-headers, zip
Restrictions: build-needed

=== debian/watch ===
version=4

opts=,\
pgpsigurlmangle=s/archive\/refs\/tags\/(\d\S+)\.tar\.gz/releases\/download\/$1\/$1\.tar\.gz\.sig/,\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\.\d+)?$//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|BETA|fp)\d*)$/$1~$2/,\
filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/pwsafe-$1\.tar\.gz/ \
https://github.com/pwsafe/pwsafe/tags .*/archive/refs/tags/v?(1\.\S+)\.tar\.gz
